package com.telpo.dipperposition.config;

import com.alibaba.nacos.api.config.annotation.NacosValue;
import com.alibaba.nacos.spring.context.annotation.config.NacosPropertySource;
import com.telpo.dipperposition.common.OkHttpUtil;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;

/**
 * @program: gateway
 * @description: jwt设置
 * @author: linwl
 * @create: 2020-06-18 17:45
 */
@Getter
@Setter
@Configuration
@NacosPropertySource(dataId="dipperposition-service", autoRefreshed=true)
public class NettyServerConfig {

  @NacosValue(value = "${position-server.serverAddr}")
  private String serverAddr;

  @NacosValue(value = "${position-server.timeAsycPort:9011}")
  private String timeAsycServerPort;

  @NacosValue(value = "${position-server.posAsycPort}")
  private String posAsycServerPort;

  @NacosValue(value = "${position-server.starsAsycPort}")
  private String starsAsycServerPort;

//  public static NettyServerConfig nettyServerConfig;
//
//  @PostConstruct
//  public void init() {
//    nettyServerConfig = this;
//  }

}
