package com.telpo.dipperposition.service;

import org.springframework.beans.factory.annotation.Autowired;

import java.io.UnsupportedEncodingException;

/**
 * @program: IDipperAstPosAsyncTaskService
 * @description: 系统预先基于省份的省会城市的经纬度作为辅助信息，
 * 根据设备请求的IP地址，从高德IP定位服务获取相关的省份，再匹配相应的位置信息作为辅助位置信息。
 * 如果匹配不到省份，则以武汉中心作为辅助为位置信息。
 * 关于IP与省份的关系保存到缓存中，用于下次使用时，先在缓存中获取匹配信息，匹配不到，再请求高德IP定位服务。
 * 高德IP定位服务：https://lbs.amap.com/api/webservice/guide/api/ipconfig。
 * @author: king
 * @create: 2021-01-17 16:24
 */
public interface IDipperAstPosAsyncTaskService {

  /**
   * 同步任务
   *
   */
  String pushAstPos(String ipAddress);

//  String pushAstPos(String ipAddress,
//                    String centerProvinceFilePath,
//                    String centerProvince,
//                    String ipPositionRequestPath,
//                    String ipPositionRequestKey) throws UnsupportedEncodingException;

}
