package com.telpo.dipperposition.service.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.telpo.dipperposition.entity.mongo.IpProvinceEntity;
import com.telpo.dipperposition.entity.mongo.ProvinceInfoEntity;
import com.telpo.dipperposition.mapper.IpProvinceMapper;
import com.telpo.dipperposition.service.IpProvinceService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import tools.BeanTools;

import java.util.List;

/**
 * @program: DataPushServer
 * @description: 推送记录服务接口实现类
 * @author: linwl
 * @create: 2020-07-20 11:09
 */
@Slf4j
@Service
public class IpProvinceServiceImpl implements IpProvinceService {

  @Autowired
  private IpProvinceMapper ipProvinceMapper;

//  private static IpProvinceService ipProvinceService;
//  /**
//   * spring会自动从ioc容器当中根据IPProvinceService类型找到ipProvinceService，当做参数传进来
//   *
//   */
//  @Override
//  public void setIPProvinceService(IpProvinceService ipProvinceService) {
//    this.ipProvinceService = ipProvinceService;
//  }
  @Override
  public boolean saveIpProvince(IpProvinceEntity entity) {
    ipProvinceMapper.save(entity);
    return true;
  }

  @Override
  public boolean romveById(String id) {

    ipProvinceMapper.deleteById(id);
    return false;
  }

  @Override
  public IpProvinceEntity getIpProvince(String ipAddress) {
    try {
      IpProvinceEntity query = new IpProvinceEntity();
      query.setIp(ipAddress);
      Example<IpProvinceEntity> example = Example.of(query);
      PageRequest pageable = PageRequest.of(0, 1);
      Page<IpProvinceEntity> data = ipProvinceMapper.findAll(example, pageable);
      if (CollectionUtil.isNotEmpty(data.getContent())) {
        List<IpProvinceEntity> records = BeanTools.copyList(data.getContent(), IpProvinceEntity.class);
        return records.get(0);
      } else {
        return null;
      }
    } catch (Exception e) {
      log.error("获取IP省份异常:", e);
      return null;
    }
  }
}
